progname=exercise_06_28
CC=g++
CFLAGS=-Wall -Wextra -Werror -g3

all: test

debug/$(progname): debug/$(progname).o
	$(CC) $(CFLAGS) $< -o $@

debug/%.s: debug/%.ii
	$(CC) -S $(CFLAGS) $< -o $@

debug/%.o: debug/%.s
	$(CC) -c $(CFLAGS) $< -o $@

debug/%.ii: %.cpp | debug
	$(CC) -E $(CFLAGS) $< -o $@

debug:
	mkdir -p debug

clean:
	rm -rf debug .gitignore 

test: debug/$(progname)
	./debug/$(progname) < $@.in > ./debug/$@.out 
	diff ./debug/$@.out $@.expected && echo PASSED || echo FAILED

.PRECIOUS: debug/%.ii  debug/%.s
.SECONDARY: debug/%.ii  debug/%.s
